/*
 * s_curl.h
 *	cf.
 *		https://qiita.com/alaif-net@github/items/e4432c374985dc38e038
 */

#ifndef __S_CURL_H__
#define __S_CURL_H__

#include <string.h>
#include <curl/curl.h>

#define MAX_BUF 65535

static char wr_buf[MAX_BUF];
static int  wr_index = 0;

static size_t write_data(void *buffer, size_t size, size_t nmemb, void *userp)
{
  int segsize = size * nmemb;

  if ((wr_index + segsize) > MAX_BUF) {
	*(int *)userp = 1;
	return 0;
  }

  memcpy((void *)&wr_buf[wr_index], buffer, (size_t)segsize);

  wr_index += segsize;

  wr_buf[wr_index] = '\0';

  return segsize;
}


static int print_url ( char *url ) {
  CURL *curl;
  CURLcode ret;
  int wr_error = 0;

  curl = curl_easy_init();
  if (curl == NULL) {
	fprintf(stderr, "curl_easy_init failed.\n");
	return 1;
  }

  curl_easy_setopt(curl, CURLOPT_URL, url );
  curl_easy_setopt(curl, CURLOPT_WRITEDATA, (void *)&wr_error);
  curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);

  //
  ret = curl_easy_perform(curl);

  printf("ret=%d (write_error=%d)\n", ret, wr_error);

  if (ret == 0) {
	printf("%s\n", wr_buf);
  }

  curl_easy_cleanup(curl);

}

#endif

